-- ftn.adb

package body Ftn is

   package Elementary_Functions renames
           Ada.Numerics.Elementary_Functions;
   package Long_Elementary_Functions renames
           Ada.Numerics.Long_Elementary_Functions;
   package Long_Long_Elementary_Functions renames
           Ada.Numerics.Long_Long_Elementary_Functions;


   function Log10  (X : Real) return Real is
   begin
      return Elementary_Functions.Log (X, 10.0);
   end;

   function Log10  (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Log (X, 10.0);
   end;

   function Log10 (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Log (X, 10.0);
   end;


   Degrees_To_Radians : constant := Ada.Numerics.Pi / 180.0;
   Radians_To_Degrees : constant := 180.0 / Ada.Numerics.Pi;


   function SinD   (X : Real) return Real is
   begin
      return Elementary_Functions.Sin (X * Degrees_To_Radians);
   end;

   function SinD  (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Sin (X * Degrees_To_Radians);
   end;

   function SinD  (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Sin (X * Degrees_To_Radians);
   end;


   function CosD  (X : Real) return Real is
   begin
      return Elementary_Functions.Cos (X * Degrees_To_Radians);
   end;

   function CosD  (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Cos (X * Degrees_To_Radians);
   end;

   function CosD  (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Cos (X * Degrees_To_Radians);
   end;


   function TanD  (X : Real) return Real is
   begin
      return Elementary_Functions.Tan (X * Degrees_To_Radians);
   end;

   function TanD  (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Tan (X * Degrees_To_Radians);
   end;

   function TanD  (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Tan (X * Degrees_To_Radians);
   end;


   function AsinD (X : Real) return Real is
   begin
      return Elementary_Functions.Arcsin (X) * Radians_To_Degrees;
   end;

   function AsinD (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Arcsin (X) * Radians_To_Degrees;
   end;

   function AsinD (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Arcsin (X) * Radians_To_Degrees;
   end;


   function AcosD (X : Real) return Real is
   begin
      return Elementary_Functions.Arccos (X) * Radians_To_Degrees;
   end;

   function AcosD (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Arccos (X) * Radians_To_Degrees;
   end;

   function AcosD (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Arccos (X) * Radians_To_Degrees;
   end;


   function Atan  (X : Real) return Real is
   begin
      return Elementary_Functions.Arctan (X);
   end;

   function Atan  (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Arctan (X);
   end;

   function Atan  (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Arctan (X);
   end;

   function AtanD (X : Real) return Real is
   begin
      return Elementary_Functions.Arctan (X) * Radians_To_Degrees;
   end;

   function AtanD (X : Double) return Double is
   begin
      return Long_Elementary_Functions.Arctan (X) * Radians_To_Degrees;
   end;

   function AtanD (X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Arctan (X) * Radians_To_Degrees;
   end;


   function Atan2 (Y, X : Real) return Real is
   begin
      return Elementary_Functions.Arctan (Y, X);
   end;

   function Atan2 (Y, X : Double) return Double is
   begin
      return Long_Elementary_Functions.Arctan (Y, X);
   end;

   function Atan2 (Y, X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Arctan (Y, X);
   end;

   function Atan2D (Y, X : Real) return Real is
   begin
      return Elementary_Functions.Arctan (Y, X) * Radians_To_Degrees;
   end;

   function Atan2D (Y, X : Double) return Double is
   begin
      return Long_Elementary_Functions.Arctan (Y, X) * Radians_To_Degrees;
   end;

   function Atan2D (Y, X : Real16) return Real16 is
   begin
      return Long_Long_Elementary_Functions.Arctan (Y, X) * Radians_To_Degrees;
   end;


   function Int   (X : Real) return Integer2 is
   begin
      return Integer2 (X);
   end;

   function Int   (X : Real) return Integer is
   begin
      return Integer (X);
   end;

   function Int   (X : Double) return Integer2 is
   begin
      return Integer2 (X);
   end;

   function Int   (X : Double) return Integer is
   begin
      return Integer (X);
   end;

   function Int   (X : Real16) return Integer2 is
   begin
      return Integer2 (X);
   end;

   function Int   (X : Real16) return Integer is
   begin
      return Integer (X);
   end;


--   function Aint  (X : Real) return Real is
--   function Aint  (X : Double) return Double is
--   function Aint  (X : Real16) return Real16 is

   function Nint  (X : Real) return Integer2 is
   begin
      return Integer2 (X);
   end;

   function Nint  (X : Real) return Integer is
   begin
      return Integer (X);
   end;

   function Nint  (X : Double) return Integer2 is
   begin
      return Integer2 (X);
   end;

   function Nint   (X : Double) return Integer is
   begin
      return Integer (X);
   end;

   function Nint   (X : Real16) return Integer2 is
   begin
      return Integer2 (X);
   end;

   function Nint   (X : Real16) return Integer is
   begin
      return Integer (X);
   end;

--   function ANint  (X : Real) return Real is
--   function DNint  (X : Double) return Double is
--   function QNint  (X : Real16) return Real16 is
--
--   function Ifix   (X : Real) return Integer2 is
--   begin
--      return Integer2 (X);
--   end;
--
--   function Ifix   (X : Real) return Integer is
--   begin
--      return Integer (X);
--   end;
--
--
--
--   function Max (A1 : Integer2;
--                 A2 : Integer2;
--                 A3 : Integer2 := Integer2'first;
--                 A4 : Integer2 := Integer2'first;
--                 A5 : Integer2 := Integer2'first;
--                 A6 : Integer2 := Integer2'first;
--                 A7 : Integer2 := Integer2'first;
--                 A8 : Integer2 := Integer2'first;
--                 A9 : Integer2 := Integer2'first;
--                 A10 : Integer2 := Integer2'first)
--            return Integer2 is
--
--   function Max (A1 : Integer;
--                 A2 : Integer;
--                 A3 : Integer := Integer'first;
--                 A4 : Integer := Integer'first;
--                 A5 : Integer := Integer'first;
--                 A6 : Integer := Integer'first;
--                 A7 : Integer := Integer'first;
--                 A8 : Integer := Integer'first;
--                 A9 : Integer := Integer'first;
--                 A10 : Integer := Integer'first)
--            return Integer is
--
--   function Max (A1 : Real;
--                 A2 : Real;
--                 A3 : Real := Real'first;
--                 A4 : Real := Real'first;
--                 A5 : Real := Real'first;
--                 A6 : Real := Real'first;
--                 A7 : Real := Real'first;
--                 A8 : Real := Real'first;
--                 A9 : Real := Real'first;
--                 A10 : Real := Real'first)
--            return Real is
--
--   function Max (A1 : Double;
--                 A2 : Double;
--                 A3 : Double := Double'first;
--                 A4 : Double := Double'first;
--                 A5 : Double := Double'first;
--                 A6 : Double := Double'first;
--                 A7 : Double := Double'first;
--                 A8 : Double := Double'first;
--                 A9 : Double := Double'first;
--                 A10 : Double := Double'first)
--            return Double is
--
--   function Max (A1 : Real16;
--                 A2 : Real16;
--                 A3 : Real16 := Real16'first;
--                 A4 : Real16 := Real16'first;
--                 A5 : Real16 := Real16'first;
--                 A6 : Real16 := Real16'first;
--                 A7 : Real16 := Real16'first;
--                 A8 : Real16 := Real16'first;
--                 A9 : Real16 := Real16'first;
--                 A10 : Real16 := Real16'first)
--            return Real16 is
--
--
--   function Min (A1 : Integer2;
--                 A2 : Integer2;
--                 A3 : Integer2 := Integer2'first;
--                 A4 : Integer2 := Integer2'first;
--                 A5 : Integer2 := Integer2'first;
--                 A6 : Integer2 := Integer2'first;
--                 A7 : Integer2 := Integer2'first;
--                 A8 : Integer2 := Integer2'first;
--                 A9 : Integer2 := Integer2'first;
--                 A10 : Integer2 := Integer2'first)
--            return Integer2 is
--
--   function Min (A1 : Integer;
--                 A2 : Integer;
--                 A3 : Integer := Integer'first;
--                 A4 : Integer := Integer'first;
--                 A5 : Integer := Integer'first;
--                 A6 : Integer := Integer'first;
--                 A7 : Integer := Integer'first;
--                 A8 : Integer := Integer'first;
--                 A9 : Integer := Integer'first;
--                 A10 : Integer := Integer'first)
--            return Integer is
--
--   function Min (A1 : Real;
--                 A2 : Real;
--                 A3 : Real := Real'first;
--                 A4 : Real := Real'first;
--                 A5 : Real := Real'first;
--                 A6 : Real := Real'first;
--                 A7 : Real := Real'first;
--                 A8 : Real := Real'first;
--                 A9 : Real := Real'first;
--                 A10 : Real := Real'first)
--            return Real is
--
--   function Min (A1 : Double;
--                 A2 : Double;
--                 A3 : Double := Double'first;
--                 A4 : Double := Double'first;
--                 A5 : Double := Double'first;
--                 A6 : Double := Double'first;
--                 A7 : Double := Double'first;
--                 A8 : Double := Double'first;
--                 A9 : Double := Double'first;
--                 A10 : Double := Double'first)
--            return Double is
--
--   function Min (A1 : Real16;
--                 A2 : Real16;
--                 A3 : Real16 := Real16'first;
--                 A4 : Real16 := Real16'first;
--                 A5 : Real16 := Real16'first;
--                 A6 : Real16 := Real16'first;
--                 A7 : Real16 := Real16'first;
--                 A8 : Real16 := Real16'first;
--                 A9 : Real16 := Real16'first;
--                 A10 : Real16 := Real16'first)
--            return Real16 is
--
--
--   function Dim    (A1, A2 : Integer2) return Integer2 is
--   function Dim    (A1, A2 : Integer) return Integer is
--   function Dim    (A1, A2 : Real) return Real is
--   function Dim    (A1, A2 : Double) return Double is
--   function Dim    (A1, A2 : Real16) return Real16 is
--
--   -- MOD() : To Be Done
--
--   function Sign   (A1, A2 : Integer2) return Integer2 is
--   function Sign   (A1, A2 : Integer) return Integer is
--   function Sign   (A1, A2 : Real) return Real is
--   function Sign   (A1, A2 : Double) return Double is
--   function Sign   (A1, A2 : Real16) return Real16 is
--


end Ftn;
